------------------------------------------------------------------------------
--                                                                          --
--                        XVIEW ADA LIBRARY COMPONENTS                      --
--                                                                          --
--                              XV_ICON_PACKAGE                             --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--          Copyright (c) 1995 Andreas Almroth, All Rights Reserved         --
--                                                                          --
-- The  XVIEW ADA  library is free software; you can redistribute it and/or --
-- modify  it  under terms of the  GNU  Library General  Public  License as --
-- published by the Free Software Foundation; either version 2, or (at your --
-- option) any later version. The XVIEW ADA library is  distributed  in the --
-- hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the --
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. --
-- See the GNU Library General Public License for more details.             --
-- You should have  received  a  copy of the  GNU  Library  General  Public --
-- License along with the XVIEW ADA library; see the file  COPYING.LIB.  If --
-- not, write to the Free  Software  Foundation, 675  Mass  Ave, Cambridge, --
-- MA 02139, USA.                                                           --
--                                                                          --
------------------------------------------------------------------------------

with Xv_Base_Package,Xv_Server_Image_Package;
use  Xv_Base_Package,Xv_Server_Image_Package;
with Ada.Finalization;
use  Ada.Finalization;

package Xv_Icon_Package is
  type Icon is new Xv_opaque;

  type Xv_Icon (Owner : Xv_Opaque; Image : Server_Image) 
  is new Controlled with private;
  type Xv_Icon_Ptr is access all Xv_Icon;

  procedure Initialize (V : in out Xv_Icon);
  procedure Finalize   (V : in out Xv_Icon);
  procedure Set_Title  (V : in Xv_Icon; txt : String);
  function  Get_Icon   (V : in Xv_Icon) return Icon;

private
   type Xv_Icon (Owner : Xv_Opaque; Image : Server_Image) 
   is new Controlled with
      record
	 Base      : Icon;
	 Parent    : Xv_Opaque := owner;
	 The_Image : Server_Image := Image;
      end record;

end Xv_Icon_Package;

