------------------------------------------------------------------------------
--                                                                          --
--                        XVIEW ADA LIBRARY COMPONENTS                      --
--                                                                          --
--                              XV_TTYSW_PACKAGE                            --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--          Copyright (c) 1995 Andreas Almroth, All Rights Reserved         --
--                                                                          --
-- The  XVIEW ADA  library is free software; you can redistribute it and/or --
-- modify  it  under terms of the  GNU  Library General  Public  License as --
-- published by the Free Software Foundation; either version 2, or (at your --
-- option) any later version. The XVIEW ADA library is  distributed  in the --
-- hope that it will be useful,  but WITHOUT ANY WARRANTY; without even the --
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. --
-- See the GNU Library General Public License for more details.             --
-- You should have  received  a  copy of the  GNU  Library  General  Public --
-- License along with the XVIEW ADA library; see the file  COPYING.LIB.  If --
-- not, write to the Free  Software  Foundation, 675  Mass  Ave, Cambridge, --
-- MA 02139, USA.                                                           --
--                                                                          --
------------------------------------------------------------------------------

with Ada.Finalization,Xv_Base_Package,Xv_Frame_Package;
use  Ada.Finalization,Xv_Base_Package,Xv_Frame_Package;
with Ada.Strings.Unbounded;
use  Ada.Strings.Unbounded;

package Xv_Ttysw_Package is
  type Ttysw is new Xv_Opaque;

---------------
-- Xv_Ttysw --
---------------

  type Xv_Ttysw (Owner : Frame; Width : Integer; Height : Integer;
		 Args : String_Ptr)
  is new Controlled with private;
--  type Xv_Ttysw (Owner : Frame := 0; Width : Integer := 80; 
--		 Height : Integer := 24; Args : String_Ptr := new String'(" "))
--  is new Controlled with private;

  type Xv_Ttysw_Ptr is access all Xv_Ttysw;

  procedure Initialize   (V : in out Xv_Ttysw);
  procedure Finalize     (V : in out Xv_Ttysw);
  procedure Set_Size     (V : in Xv_Ttysw; W, H : Integer);
  procedure Set_Pos      (V : in Xv_Ttysw; X, Y : Integer);
  function  Input        (V : in Xv_Ttysw; Cmd : String) return Integer;
  function  Output       (V : in Xv_Ttysw; Cmd : String) return Integer;
  function  Get_Ttysw    (V : in Xv_Ttysw) return Ttysw;

-------------------------------------------------------------------------------

private
  type Xv_Ttysw (Owner : Frame; Width : Integer; 
		 Height : Integer; Args : String_Ptr)
--  type Xv_Ttysw (Owner : Frame := 0; Width : Integer := 80; 
--		 Height : Integer := 24; Args : String_Ptr := new String'(" "))
  is new Controlled with
     record
	Base     : Ttysw;
	Parent   : Frame := Owner;
	Columns  : Integer := Width;
	Rows     : Integer := Height;
	TTY_Args : String_Ptr := Args;
     end record;
end Xv_Ttysw_Package;

